/* 
 * File:   factorizationalgorithm.cpp
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 17, 2009, 12:35 PM
 */

#include "includes/factorizationalgorithm.h"

#include <iostream>

FactorizationAlgorithm::~FactorizationAlgorithm() {
    if( n != NULL ) {
        delete n;
    }
}


void FactorizationAlgorithm::showProgress(mpz_class* curr, mpz_class* start, mpz_class* end) {
    mpq_class cent( 100 );

    mpq_class pr( (*end) );
    mpq_class sq( (*curr) );
    mpq_class st( (*start) );
    
    mpq_sub( pr.get_mpq_t(), pr.get_mpq_t(), st.get_mpq_t() );
    mpq_sub( sq.get_mpq_t(), sq.get_mpq_t(), st.get_mpq_t() );
    
    mpq_div( pr.get_mpq_t(), sq.get_mpq_t(), pr.get_mpq_t() );
    mpq_mul( pr.get_mpq_t(), pr.get_mpq_t(), cent.get_mpq_t() );

    std::cout << "\rProgress: " << pr.get_d() << "%            ";
}
