/* 
 * File:   highrestimer.cpp
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 24, 2009, 12:08 PM
 */

#include "includes/highrestimer.h"
#include <sys/time.h>

HighResTimer::HighResTimer() {
    reset();
}


HighResTimer::~HighResTimer() {
}

void HighResTimer::start() {
    gettimeofday( &tvstart, 0 );
    stopped = false;
}

void HighResTimer::reset() {
    gettimeofday( &tvstart, 0 );
    gettimeofday( &tvstop, 0 );
    stopped = true;
}

void HighResTimer::stop() {
    gettimeofday( &tvstop, 0 );
    stopped = true;
}

long unsigned int HighResTimer::getMicroSecondsElapsed() {
    struct timeval tvelapsed;
    struct timeval tvtemp;
    if( stopped )
        timersub( &tvstop, &tvstart, &tvelapsed );
    else {
        gettimeofday( &tvtemp, 0 );
        timersub( &tvtemp, &tvstart, &tvelapsed );
    }
    
    return (tvelapsed.tv_sec*1000000) + tvelapsed.tv_usec;
}