/* 
 * File:   ecmfactorizator.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 22, 2009, 4:49 PM
 */

#ifndef _ECMFACTORIZATOR_H
#define	_ECMFACTORIZATOR_H


#include "../factorizationalgorithm.h"

class ECMFactorizator : public FactorizationAlgorithm {
public:
    ECMFactorizator() : FactorizationAlgorithm( NULL ) { };
    virtual ~ECMFactorizator();

    virtual FactorizationAlgorithm* newInstance( mpz_class* n );
    mpz_class* findNonTrivialFactor();
    std::string getName();

protected:
    ECMFactorizator( mpz_class* n ) : FactorizationAlgorithm( n ) {};
};

#endif	/* _ECMFACTORIZATOR_H */

