/* 
 * File:   fermatfactorizator.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 20, 2009, 11:36 AM
 */

#ifndef _FERMATFACTORIZATOR_H
#define	_FERMATFACTORIZATOR_H

#include "../factorizationalgorithm.h"

class FermatFactorizator : public FactorizationAlgorithm {
public:
    FermatFactorizator() : FactorizationAlgorithm( NULL ) { };
    virtual ~FermatFactorizator();

    virtual FactorizationAlgorithm* newInstance( mpz_class* n );
    mpz_class* findNonTrivialFactor();
    std::string getName();

protected:
    FermatFactorizator( mpz_class* n ) : FactorizationAlgorithm( n ) {};
};

#endif	/* _FERMATFACTORIZATOR_H */

