/* 
 * File:   exceptions.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 18, 2009, 12:27 PM
 */

#ifndef _EXCEPTIONS_H
#define	_EXCEPTIONS_H

namespace infact {

    class InfactException {
        public:
            InfactException( int errcode, std::string desc ) { this->err = errcode; this->errstr = desc; }
            virtual ~InfactException() {  };
            std::string getDesc() { return errstr; }
            int getErrCode() { return err; }
        private:
            std::string errstr;
            int err;
    };

    class FactorizationFailureException : public InfactException {
        public:
            FactorizationFailureException( std::string desc ) : InfactException( 2, desc ) { };
    };


    class PrimeFactorizationException : public InfactException {
        public:
            PrimeFactorizationException() : InfactException( 1, "Number is prime.") {};
    };
}

#endif	/* _EXCEPTIONS_H */

