/* 
 * File:   factorizationalgorithm.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 17, 2009, 12:35 PM
 */

#ifndef _FACTORIZATIONALGORITHM_H
#define	_FACTORIZATIONALGORITHM_H

#include <gmpxx.h>
#include "exceptions.h"


class FactorizationAlgorithm {
public:
    virtual ~FactorizationAlgorithm();

    virtual FactorizationAlgorithm* newInstance( mpz_class* n ) = 0;
    virtual mpz_class* findNonTrivialFactor() = 0;
    virtual std::string getName() = 0;
    mpz_class* getN() { return n; }

protected:
    FactorizationAlgorithm( mpz_class* n ) { this->n = n; }
    void showProgress( mpz_class* curr, mpz_class* start, mpz_class* end );
    mpz_class* n;
};

#endif	/* _FACTORIZATIONALGORITHM_H */

