/* 
 * File:   factorizationalgorithmfactory.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 18, 2009, 1:20 PM
 */

#ifndef _FACTORIZATIONALGORITHMFACTORY_H
#define	_FACTORIZATIONALGORITHMFACTORY_H

#include "factorizationalgorithm.h"
#include <gmpxx.h>
#include <vector>

class FactorizationAlgorithmFactory {
public:
    FactorizationAlgorithmFactory();
    virtual ~FactorizationAlgorithmFactory();

    FactorizationAlgorithm* newInstance( mpz_class* n, std::string name );
    std::string availableAlgorithmsDescriptionString();
    std::vector< std::string >* getAlgorithmsNames();
    
private:
    std::vector< FactorizationAlgorithm* > *algorithms;
};

#endif	/* _FACTORIZATIONALGORITHMFACTORY_H */

