/* 
 * File:   highrestimer.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 24, 2009, 12:08 PM
 */

#ifndef _HIGHRESTIMER_H
#define	_HIGHRESTIMER_H

#include <sys/time.h>
#include "infact.h"

class HighResTimer {
public:
    HighResTimer();
    virtual ~HighResTimer();
    void start();
    void reset();
    void stop();
    long unsigned int getMicroSecondsElapsed();
    
private:
    struct timeval tvstart;
    struct timeval tvstop;
    bool stopped;
};

#endif	/* _HIGHRESTIMER_H */

