/* 
 * File:   mpnumbergenerator.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 16, 2009, 5:58 PM
 */

#ifndef _MPNUMBERGENERATOR_H
#define	_MPNUMBERGENERATOR_H

#include <gmpxx.h>


class MPNumberGenerator {

public:
    MPNumberGenerator();
    MPNumberGenerator(const MPNumberGenerator& orig);
    virtual ~MPNumberGenerator();

    mpz_class* generatePrime( unsigned int nbits, unsigned int attempts );
    mpz_class* generateComposite( unsigned int nbits, unsigned int attempts );
    mpz_class* generate2pComposite( unsigned int nbits, unsigned int attempts );

    mpz_class* generateRand( mpz_class* max );
private:
    gmp_randclass* gmprand;
    bool cloned;
};

#endif	/* _MPNUMBERGENERATOR_H */

